﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;
using System.IO;
using System.Text.RegularExpressions;

namespace xkcdDownloader
{
	class Program
	{
		static void Main(string[] args)
		{
			Console.WriteLine("Starting");
			StringBuilder desc = new StringBuilder();
			
			for (int i = 1; i < 792; i++)
			{
				Console.WriteLine(@"Processing: http://xkcd.com/" + i.ToString() + @"/");


				WebClient Client = new WebClient();
				Stream strm = null;

				try
				{
					strm = Client.OpenRead("http://xkcd.com/" + i.ToString() + "/");

					StreamReader sr = new StreamReader(strm);
					StringBuilder sb = new StringBuilder();
					string line;

					do
					{
						line = sr.ReadLine();
						sb.AppendLine(line);
					}
					while (line != null);

					Console.WriteLine(@"Parsing");
					//<img src="http://imgs.xkcd.com/comics/girl_sleeping_noline_(1).jpg" title="I don&#39;t remember her name at all, but she fell asleep on the floor in front of me." alt="Girl sleeping (Sketch -- 11th grade Spanish class)" />
					Regex myPat = new Regex("<img src=\"(.*)\" title=\"(.*)\" alt=\"(.*)\" />");
					//String myPat = "<img src=\"(.*)\" title=\"(.*)\" alt=\"(.*)\" />";
					Match m = myPat.Match(sb.ToString());

					if (m.Success)
					{
						String src = myPat.Replace(m.Value, "$1");
						String title = myPat.Replace(m.Value, "$2");
						title = ReplaceSpecialCharacters(title);
						String alt = myPat.Replace(m.Value, "$3");
						alt = ReplaceSpecialCharacters(alt);
						String filename = i.ToString() + "_" + src.Substring(src.LastIndexOf('/') + 1);
						Console.WriteLine("Writing file description");
						
						if (!filename.Contains(' '))
						{
							desc.AppendLine(filename + " " + alt + "\t"+ title);
						}
						else
						{
							desc.AppendLine("\"" + filename + "\"" + " " + alt +"\t" + title);
						}

						Console.WriteLine("Downloading image");

						Client = new WebClient();
						Client.DownloadFile(src, filename);
						Console.WriteLine("Downloaded");
					}


				}
				catch(Exception ex)
				{
					Console.WriteLine("-fail-");
				}
				finally
				{
					if (strm != null)
					{
						strm.Close();
					}
				}
				StreamWriter sw = new StreamWriter("descript.ion");
				sw.Write(desc.ToString());
				sw.Close();
			}
			Console.WriteLine("Finished");
			Console.ReadKey();
		}

		private static string ReplaceSpecialCharacters(string Input)
		{
			Input = Input.Replace("&#39;", "'");
			Input = Input.Replace("&amp;", "&");
			Input = Input.Replace("&apos;", "'");
			Input = Input.Replace("&#x22;", "\"");
			Input = Input.Replace("&#x2039;", "<");
			Input = Input.Replace("&#x203A;", ">");
			Input = Input.Replace("&gt;", ">=");
			Input = Input.Replace("&lt;", "<=");

			return Input;
		}
	}
}
